const readline = require("readline");
const read = require('fs-readdir-recursive');
const fs = require('fs');

const reader = readline.createInterface({
  input: process.stdin,
  output: process.stdout
});

console.log('\nInnan vi forsätter med uppgraderingen måste du se' +
  '\ntill att du står i rotmappen av projektet du vill uppgradera.');
console.log('\nDessutom att du inte har några ändringar som inte är committade' +
  '\ni din branch.');

console.log('\nObs! att detta script endast går igenom och uppdaterar htmlfilerna i ditt projekt,\n'
 + 'finns det ändra typer av filer som innehåller kod från designsystem som t.ex. less, scss etc. så får ni manuellt justera dessa');

reader.question("\nVill du fortsätta? (y/n)", async function(svar) {

  if (svar.toLowerCase() == 'y') {

    console.log('Letar efter alla html filer.')
    const htmlFiles = read(process.cwd())
      .filter(item => item.endsWith(".html"))
      .filter(item => !item.startsWith("node_modules"))
      .filter(item => !item.startsWith("dist"));

    for (const htmlFile of htmlFiles) {
      lookingForJvCheckbox(htmlFile);
      lookingForJvDynamiskInput(htmlFile);
      lookingForJvMultiSelect(htmlFile);
      lookingForJvMultitext(htmlFile);
      lookingForJvRadioBtn(htmlFile);
      lookingForJvToggle(htmlFile);
      lookingForJvAccordion(htmlFile);
      lookingForJvFormGroup(htmlFile);
    }

    await reader.close();
  } else {
    await reader.close();
  }
});

const lookingForJvCheckbox = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-checkbox.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-checkbox([^>]+)>$/gm));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st webbkomponent checkboxar i filen ' + htmlFile);
    }
  }
  if (/class=".*c-checkbox--medium/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-checkbox--medium/gm, 'c-checkbox--medium', 'c-checkbox--small'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st medium checkboxar i filen ' + htmlFile);
    }
  }

  if (/class=".*c-checkbox--large/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-checkbox--large/gm, 'c-checkbox--large', 'c-checkbox--medium'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st large checkboxar i filen ' + htmlFile);
    }
  }
}

const lookingForJvDynamiskInput = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-dynamisk-input.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-dynamisk-input([^>]*)>$/gm));
    

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
       + nbrOfString + 'st inputfält i filen ' + htmlFile);
    }
  }

  data = updateCSSClassForInput(data, htmlFile);
  data = updateCSSClassForSingleSelect(data,  htmlFile);
  data = updateCSSClassForTextarea(data, htmlFile);
}

const lookingForJvMultiSelect = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-multi-select.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-multi-select([^>]+)>$/gm));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st multi-select i filen ' + htmlFile);
    }
  }
}

const lookingForJvMultitext = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-multitext.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-multitext([^>]+)>$/gm));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st multitext i filen ' + htmlFile);
    }
  }
}

const lookingForJvRadioBtn = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-radio-button.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-radio-button([^>]+)>$/gm));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st radioknappar i filen ' + htmlFile);
    }
  }

  if (/class=".*c-radio-btn--medium/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-radio-btn--medium/gm, 'c-radio-btn--medium', 'c-radio-btn--small'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st medium radioknappar i filen ' + htmlFile);
    }
  }

  if (/class=".*c-radio-btn--large/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-radio-btn--large/gm, 'c-radio-btn--large', 'c-radio-btn--medium'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st large radioknappar i filen ' + htmlFile);
    }
  }
}

const lookingForJvToggle = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-toggle.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-toggle([^>]+)>$/gm));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st toggle(s) i filen ' + htmlFile);
    }
  }
}

const lookingForJvAccordion = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/<jv-accordion.*>/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdate(data, nbrOfString, /<jv-accordion([^>]+)>$/gm));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st accorions i filen ' + htmlFile);
    }
  }
}

const lookingForJvFormGroup = function(htmlFile) {

  let data = fs.readFileSync(htmlFile, 'utf8');
  let nbrOfString = 0;
  if (/jv-form-group>/i.test(data)) {
    data = data.replace(/jv-form-group/g, "jv-fieldset");
    writeToFile(htmlFile, data, '\nHittat och ersatt '
    + 'formgroup webbkomponent med fieldset i filen ' + htmlFile);
  }

  if (/class=".*c-form-group--medium/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-form-group--medium/gm, 'c-form-group--medium', 'c-fieldset--small'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st medium form-group i filen ' + htmlFile);
    }
  }

  if (/class=".*c-form-group--large/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-form-group--large/gm, 'c-form-group--large', 'c-fieldset--medium'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st large form-group i filen ' + htmlFile);
    }
  }

  if (/class=".*c-form-group--error/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-form-group--error/gm, 'c-form-group--error', 'c-fieldset--error'));
    
    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
      + nbrOfString + 'st large form-group i filen ' + htmlFile);
    }
  }
}

reader.on("close", function() {
  console.log("\nAvslutar!");
  process.exit(0);
});

function updateCSSClassForInput(data, htmlFile) {
  let nbrOfString = 0;
  if (/class=".*c-input--medium/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-input--medium/gm, 'c-input--medium', 'c-input--small'));

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
        + nbrOfString + 'st medium inputfält i filen ' + htmlFile);
    }
  }

  if (/class=".*c-input--large/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-input--large/gm, 'c-input--large', 'c-input--medium'));

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
        + nbrOfString + 'st large inputfält i filen ' + htmlFile);
    }
  }
  return data;
}

function updateCSSClassForSingleSelect(data, htmlFile) {
  let nbrOfString = 0;
  if (/class=".*c-select--medium/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-select--medium/gm, 'c-select--medium', 'c-select--small'));

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
        + nbrOfString + 'st medium single-select i filen ' + htmlFile);
    }
  }

  if (/class=".*c-select--large/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-select--large/gm, 'c-select--large', 'c-select--medium'));

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
        + nbrOfString + 'st large single-select i filen ' + htmlFile);
    }
  }
  return data;
}

function updateCSSClassForTextarea(data, htmlFile) {
  let nbrOfString = 0;
  if (/class=".*c-textarea--medium/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-textarea--medium/gm, 'c-textarea--medium', 'c-textarea--small'));

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
        + nbrOfString + 'st medium textytor i filen ' + htmlFile);
    }
  }

  if (/class=".*c-textarea--large/i.test(data)) {
    ({ data, nbrOfString } = findAndUpdateClass(data, /class=".*c-textarea--large/gm, 'c-textarea--large', 'c-textarea--medium'));

    if (nbrOfString > 0) {
      writeToFile(htmlFile, data, '\nHittat och uppdaterat '
        + nbrOfString + 'st large textytor i filen ' + htmlFile);
    }
  }
  return data;
}

function findAndUpdateClass(data, regexp, stringToMatch, replaceString) {
  let nbrOfString = 0;
  const matchingArray = data.match(regexp);
  if (!matchingArray) {
    return { data, nbrOfString };
  }
  for (const matchingString of matchingArray) {
    if (matchingString.includes(stringToMatch)) {
      data = replaceAll(data, matchingString, matchingString.replace(stringToMatch, replaceString));
      nbrOfString = nbrOfString + 1;
    }
  }
  return { data, nbrOfString };
}

function findAndUpdate(data, nbrOfString, regexp) {
  const matchingArray = data.match(regexp);
  if (!matchingArray) {
    return { data, nbrOfString };
  }
  for (const matchingString of matchingArray) {
    if (matchingString.match('size="medium"') || matchingString.match('size="MEDIUM"')) {
      data = replaceAll(data, matchingString, matchingString.replace('size="medium"', 'size="small"'));
      data = replaceAll(data, matchingString, matchingString.replace('size="MEDIUM"', 'size="small"'));
      nbrOfString = nbrOfString + 1;
    }
    if (matchingString.match('size="large"') || matchingString.match('size="LARGE"')) {
      data = replaceAll(data, matchingString, matchingString.replace('size="large"', 'size="medium"'));
      data = replaceAll(data, matchingString, matchingString.replace('size="LARGE"', 'size="medium"'));
      nbrOfString = nbrOfString + 1;
    }
  }
  return { data, nbrOfString };
}

function writeToFile(htmlFile, data, message) {
  fs.writeFileSync(htmlFile, data, 'utf8');
  console.log(message);
}

function replaceAll(string, match, replaceString) {
  return string.split(match).join(replaceString);
}